#include "data/generic.hpp"

#include <fstream>
#include <sstream>

#include <boost/filesystem.hpp>

namespace fs = boost::filesystem;

using namespace data;

shristr data::open_read(const std::string &pfname)
{
	// TODO: ZIPfile.
	
	// TODO: Datadir ZIPfile.
	
	return shristr(new std::ifstream(open_search(pfname).c_str(), std::ifstream::binary));
}

shrostr data::open_write(const std::string &pfname)
{
	shrostr ret(new std::ofstream(pfname.c_str()));
	if(ret->fail())
	{
		std::stringstream sstr;
		sstr << "could not open \"" << pfname << "\" for writing";
		BOOST_THROW_EXCEPTION(std::runtime_error(sstr.str()));
	}	
	return ret;
}

std::string data::open_search(const std::string &pfname)
{
	fs::path fpath(pfname);

#if defined(DATADIR)
	if(!fs::exists(fpath))
	{
		fpath = fs::path(DATADIR) / pfname;
		if(!fs::exists(fpath))
		{
			std::stringstream err;
			err << "could not find file: \"" << pfname << "\"";
			BOOST_THROW_EXCEPTION(std::runtime_error(err.str()));
		}
	}
#endif

	return fpath.file_string();
}

