#include "gfx/mesh_ball.hpp"

#include "gfx/shader.hpp"

using namespace gfx;

MeshBall::MeshBall(unsigned subdivision, unsigned subdivision_coalesce)
{
	this->compile(subdivision, subdivision_coalesce);
}

void MeshBall::compile()
{
	this->compile(0);
}

void MeshBall::compile(unsigned subdivision, unsigned subdivision_coalesce)
{
	this->subdivide(subdivision);

	this->coalesce(subdivision_coalesce, subdivision);

	this->calcNormals();

	_buf.update(_texcoord, _color, _normal, _vertex);
	_elem.update(_lod);
	_lod.compile(_vertex);
}

void MeshBall::draw(const Shader &psh, const math::mat4f &pmat) const
{
	_buf.feed(psh.getAttrTexcoord(), psh.getAttrColor(), psh.getAttrNormal(),
  		psh.getAttrVertex());
	_elem.bind();
	_lod.draw(pmat);
}

void MeshBall::unreserve()
{
	_buf.unreserve();
	this->Mesh::unreserve();
}

