#ifndef OB_MISSILE_ANTI
#define OB_MISSILE_ANTI

#include "ob_missile.hpp"

namespace ob
{
	/** \brief Anti-missile.
	 *
	 * Anti-ship OR anti-nuke.
	 */
	class MissileAnti :
		public Missile
	{
		private:
			/** Target to home on. */
			const Missile *m_target;

		public:
			/** \brief Accessor.
			 * 
			 * @return Target.
			 */
			const Missile* getTarget() const
			{
				return m_target;
			}

		public:
			/** \brief Constructor.
			 *
			 * Target may be NULL to fire player instead.
			 *
			 * @param pos Position.
			 * @param dir Direction.
			 * @param tgt Target missile.
			 */
			MissileAnti(const math::vec3d &pos, const math::vec3d &dir,
					const Missile *tgt);

			/** \brief Destructor. */
			virtual ~MissileAnti() { }

		public:
			/** \cond */
			virtual math::vec3d getTargetPos() const;
			virtual bool update();
			/** \endcond */
	};
}

#endif
