#include "ob_visualization_mesh.hpp"

#include "gfx/shader.hpp"
#include "thr/dispatch.hpp"

using namespace ob;

VisualizationMesh::VisualizationMesh(const std::string &pfname)
{
	this->load(pfname);
}

void VisualizationMesh::compile()
{
	thr::dispatch_privileged(boost::bind(&gfx::BufferInterleavedTCV::update,
				&_buf, boost::ref(_texcoord), boost::ref(_color),
				boost::ref(_vertex)));
	thr::wait_privileged(boost::bind(&Mesh::taskElem, this));
	_lod.compile(_vertex);
}

void VisualizationMesh::draw(const gfx::Shader &psh, const math::mat4f &pmat) const
{
	if(!_textures.empty())
	{
		_textures[0]->bind(psh.getUniformTex(), 0);
	}

	_buf.feed(psh.getAttrTexcoord(), psh.getAttrColor(), psh.getAttrVertex());
	_elem.bind();
	_lod.draw(pmat);
}

